part of kitcod_uikit_flutter;

class KitcodApi {
  KitcodApi._();

  static final KitcodApi _instance = KitcodApi._();

  static KitcodApi get instance => _instance;

  Future<List<CommentList>> getPostCommentData() async {
    final response = await http.get(Uri.parse(
        "https://628f5fd6dc478523653f60fd.mockapi.io/kitcod-api-comments"));
    final jsonData = jsonDecode(response.body);
    final List<CommentList> feedPostComments = [];
    // ignore: avoid_dynamic_calls
    for (final feed in jsonData["_embedded"]["commentList"]) {
      // ignore: avoid_dynamic_calls
      final CommentList feedComments =
          CommentList.fromJson(feed as Map<String, dynamic>);
      feedPostComments.add(feedComments);
    }
    return feedPostComments;
  }

  Future<List<CommunitiesList>> getGroupsData() async {
    final response = await http.get(Uri.parse(
        "https://628f5fd6dc478523653f60fd.mockapi.io/kitcod-api-communities"));
    final jsonData = jsonDecode(response.body);
    final List<CommunitiesList> feedGroupUsers = [];
    // ignore: avoid_dynamic_calls
    for (final feed in jsonData["_embedded"]["communityList"]) {
      // ignore: avoid_dynamic_calls
      final CommunitiesList feedGroup =
          CommunitiesList.fromJson(feed as Map<String, dynamic>);
      feedGroupUsers.add(feedGroup);
    }
    return feedGroupUsers;
  }

  Future<UserProfile> getUserProfileData() async {
    final response = await http.get(Uri.parse(
        "https://628f5fd6dc478523653f60fd.mockapi.io/kitcodendpoint-user-profile"));
    final jsonData = jsonDecode(response.body);
    final UserProfile userProfile =
        UserProfile.fromJson(jsonData as Map<String, dynamic>);
    return userProfile;
  }

  Future<List<PostList>> getPostsData() async {
    final response = await http.get(Uri.parse(
        "https://628f5fd6dc478523653f60fd.mockapi.io/kitcod-api-posts"));
    final jsonData = jsonDecode(response.body);
    final List<PostList> feedPostUsers = [];
    // ignore: avoid_dynamic_calls
    for (final feed in jsonData["_embedded"]["postList"]) {
      // ignore: avoid_dynamic_calls
      final PostList feedPost = PostList.fromJson(feed as Map<String, dynamic>);
      feedPostUsers.add(feedPost);
    }
    return feedPostUsers;
  }
}
